Coin: SoMultiTextureImageElement Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
SoMultiTextureImageElement Class Reference
Element Classes

The SoMultiTextureImageElement class is yet to be documented. More...

`#include <Inventor/elements/SoMultiTextureImageElement.h>`

Inheritance diagram for SoMultiTextureImageElement:

## Classes
class | UnitData

## Public Types
enum | Model { BLEND = 0x0be2 , MODULATE = 0x2100 , DECAL = 0x2101 , REPLACE = 0x1E01 }
enum | Wrap { CLAMP = 0x2900 , REPEAT = 0x2901 , CLAMP_TO_BORDER = 0x812D }

## Public Member Functions
virtual void | init (SoState *state)
virtual void | push (SoState *state)
virtual SbBool | matches (const SoElement *elem) const
SoElement * | copyMatchInfo (void) const
virtual void | setElt (const int unit, const SbUniqueId nodeid, const SbVec2s &size, const int numComponents, const unsigned char *bytes, const Wrap wrapS, const Wrap wrapT, const Model model, const SbColor &blendColor)
| FIXME: write doc.
virtual void | setElt (const int unit, const SbUniqueId nodeid, const SbVec3s &size, const int numComponents, const unsigned char *bytes, const Wrap wrapS, const Wrap wrapT, const Wrap wrapR, const Model model, const SbColor &blendColor)
virtual SbBool | hasTransparency (const int unit=0) const
Public Member Functions inherited from SoElement
const SoType | getTypeId (void) const
int | getStackIndex (void) const
virtual void | pop (SoState *state, const SoElement *prevTopElement)
void | setDepth (const int depth)
int | getDepth (void) const
virtual void | print (FILE *file=stdout) const
virtual | ~SoElement ()

## Static Public Member Functions
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
static void | setDefault (SoState *const state, SoNode *const node, const int unit=0)
static void | set (SoState *const state, SoNode *const node, const int unit, const SbVec2s &size, const int numComponents, const unsigned char *bytes, const Wrap wrapS, const Wrap wrapT, const Model model, const SbColor &blendColor)
| FIXME: write doc.
static void | set (SoState *const state, SoNode *const node, const int unit, const SbVec3s &size, const int numComponents, const unsigned char *bytes, const Wrap wrapS, const Wrap wrapT, const Wrap wrapR, const Model model, const SbColor &blendColor)
static const unsigned char * | get (SoState *const state, const int unit, SbVec2s &size, int &numComponents, Wrap &wrapS, Wrap &wrapT, Model &model, SbColor &blendColor)
| FIXME: write doc.
static const unsigned char * | get (SoState *const state, const int unit, SbVec3s &size, int &numComponents, Wrap &wrapS, Wrap &wrapT, Wrap &wrapR, Model &model, SbColor &blendColor)
static const unsigned char * | getImage (SoState *const state, const int unit, SbVec2s &size, int &numComponents)
static const unsigned char * | getImage (SoState *const state, const int unit, SbVec3s &size, int &numComponents)
static const SbColor & | getBlendColor (SoState *const state, const int unit=0)
static Model | getModel (SoState *const state, const int unit=0)
static Wrap | getWrapS (SoState *const state, const int unit=0)
static Wrap | getWrapT (SoState *const state, const int unit=0)
static Wrap | getWrapR (SoState *const state, const int unit=0)
static SbBool | containsTransparency (SoState *const state)
| FIXME: write doc.
static const unsigned char * | getDefault (SbVec2s &size, int &numComponents)
| FIXME: write doc.
static const unsigned char * | getDefault (SbVec3s &size, int &numComponents)
static void | set (SoState *const state, SoNode *const node, const SbVec2s &size, const int numComponents, const unsigned char *bytes, const int wrapS, const int wrapT, const int model, const SbColor &blendColor)
static void | set (SoState *const state, SoNode *const node, const SbVec2s &size, const int numComponents, const unsigned char *bytes, const Wrap wrapS, const Wrap wrapT, const Model model, const SbColor &blendColor)
static void | set (SoState *const state, SoNode *const node, const SbVec3s &size, const int numComponents, const unsigned char *bytes, const int wrapS, const int wrapT, const int wrapR, const int model, const SbColor &blendColor)
static void | set (SoState *const state, SoNode *const node, const SbVec3s &size, const int numComponents, const unsigned char *bytes, const Wrap wrapS, const Wrap wrapT, const Wrap wrapR, const Model model, const SbColor &blendColor)
static const unsigned char * | get (SoState *const state, SbVec2s &size, int &numComponents, Wrap &wrapS, Wrap &wrapT, Model &model, SbColor &blendColor)
static const unsigned char * | get (SoState *const state, SbVec3s &size, int &numComponents, Wrap &wrapS, Wrap &wrapT, Wrap &wrapR, Model &model, SbColor &blendColor)
static const unsigned char * | get (SoState *const state, SbVec2s &size, int &numComponents, int &wrapS, int &wrapT, int &model, SbColor &blendColor)
static const unsigned char * | get (SoState *const state, SbVec3s &size, int &numComponents, int &wrapS, int &wrapT, int &wrapR, int &model, SbColor &blendColor)
static const unsigned char * | getImage (SoState *const state, SbVec2s &size, int &numComponents)
static const unsigned char * | getImage (SoState *const state, SbVec3s &size, int &numComponents)
Static Public Member Functions inherited from SoElement
static void | initClass (void)
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initElements (void)
static int | getNumStackIndices (void)
static SoType | getIdFromStackIndex (const int stackIndex)

## Protected Member Functions
virtual | ~SoMultiTextureImageElement ()
const UnitData & | getUnitData (const int unit) const
int | getNumUnits () const
Protected Member Functions inherited from SoElement
| SoElement (void)
void | capture (SoState *const state) const
virtual void | captureThis (SoState *state) const
void | setTypeId (const SoType typeId)
void | setStackIndex (const int index)
SoElement * | getNextInStack (void) const
SoElement * | getNextFree (void) const

## Additional Inherited Members
Static Protected Member Functions inherited from SoElement
static SoElement * | getElement (SoState *const state, const int stackIndex)
static const SoElement * | getConstElement (SoState *const state, const int stackIndex)
static int | createStackIndex (const SoType id)
Protected Attributes inherited from SoElement
SoType | typeId
int | stackIndex
int | depth
Static Protected Attributes inherited from SoElement
static int | classStackIndex
static SoTypeList * | stackToType

## Detailed Description

The SoMultiTextureImageElement class is yet to be documented.

FIXME: write doc.

Be aware that this class is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
  Coin 2.2

## Constructor & Destructor Documentation

## ◆ ~SoMultiTextureImageElement()

SoMultiTextureImageElement::~SoMultiTextureImageElement | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoMultiTextureImageElement::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getClassStackIndex()

int SoMultiTextureImageElement::getClassStackIndex | ( | void |  | ) |
| static

This static method returns the state stack index for the class.

## ◆ createInstance()

void * SoMultiTextureImageElement::createInstance | ( | void |  | ) |
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Creates a new instance of the class type corresponding to the SoType object.

## ◆ initClass()

void SoMultiTextureImageElement::initClass | ( | void |  | ) |
| static

Initialize relevant common data for all instances, like the type system.

## ◆ init()

void SoMultiTextureImageElement::init | ( | SoState * | state | ) |
| virtual

Initializes the element to its default value.

Reimplemented from SoElement.

Reimplemented in SoGLMultiTextureImageElement.

## ◆ setDefault()

void SoMultiTextureImageElement::setDefault | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const int | unit = 0 )
| static

Resets this element to its original values.

## ◆ set()

void SoMultiTextureImageElement::set | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const int | unit,
|  | const SbVec3s & | size,
|  | const int | numComponents,
|  | const unsigned char * | bytes,
|  | const Wrap | wrapS,
|  | const Wrap | wrapT,
|  | const Wrap | wrapR,
|  | const Model | model,
|  | const SbColor & | blendColor )
| static

FIXME: write doc.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

## ◆ get()

const unsigned char * SoMultiTextureImageElement::get | ( | SoState *const | state,
|  | const int | unit,
|  | SbVec3s & | size,
|  | int & | numComponents,
|  | Wrap & | wrapS,
|  | Wrap & | wrapT,
|  | Wrap & | wrapR,
|  | Model & | model,
|  | SbColor & | blendColor )
| static

FIXME: write doc.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

## ◆ getImage() [1/2]

const unsigned char * SoMultiTextureImageElement::getImage | ( | SoState *const | state,
|  | const int | unit,
|  | SbVec2s & | size,
|  | int & | numComponents )
| static

FIXME: write doc

## ◆ getImage() [2/2]

const unsigned char * SoMultiTextureImageElement::getImage | ( | SoState *const | state,
|  | const int | unit,
|  | SbVec3s & | size,
|  | int & | numComponents )
| static

FIXME: write doc

## ◆ getBlendColor()

const SbColor & SoMultiTextureImageElement::getBlendColor | ( | SoState *const | state,
|  | const int | unit = 0 )
| static

FIXME: write doc.

## ◆ getModel()

SoMultiTextureImageElement::Model SoMultiTextureImageElement::getModel | ( | SoState *const | state,
|  | const int | unit = 0 )
| static

FIXME: write doc.

## ◆ getWrapS()

SoMultiTextureImageElement::Wrap SoMultiTextureImageElement::getWrapS | ( | SoState *const | state,
|  | const int | unit = 0 )
| static

FIXME: write doc.

## ◆ getWrapT()

SoMultiTextureImageElement::Wrap SoMultiTextureImageElement::getWrapT | ( | SoState *const | state,
|  | const int | unit = 0 )
| static

FIXME: write doc.

## ◆ getWrapR()

SoMultiTextureImageElement::Wrap SoMultiTextureImageElement::getWrapR | ( | SoState *const | state,
|  | const int | unit = 0 )
| static

FIXME: write doc.

## ◆ getDefault()

const unsigned char * SoMultiTextureImageElement::getDefault | ( | SbVec3s & | size,
|  | int & | numComponents )
| static

FIXME: write doc.

## ◆ push()

void SoMultiTextureImageElement::push | ( | SoState * | state | ) |
| virtual

This method is called every time a new element is required in one of the stacks. This happens when a writable element is requested, using SoState::getElement() or indirectly SoElement::getElement(), and the depth of the current element is less than the state depth.

Override this method if your element needs to copy data from the previous top of stack. The push() method is called on the new element, and the previous element can be found using SoElement::getNextInStack().

Reimplemented from SoElement.

Reimplemented in SoGLMultiTextureImageElement.

## ◆ matches()

SbBool SoMultiTextureImageElement::matches | ( | const SoElement * | element | ) | const
| virtual

This function returns `TRUE` is the element matches another element (of the same class), with respect to cache validity.

If the application programmer's extension element has a matches() function, it should also have a copyMatchInfo() function.

Implements SoElement.

## ◆ copyMatchInfo()

SoElement * SoMultiTextureImageElement::copyMatchInfo | ( | void |  | ) | const
| virtual

This function creates a copy of the element that contains enough information to enable the matches() function to work.

Used to help with scene graph traversal caching operations.

Implements SoElement.

## ◆ setElt()

void SoMultiTextureImageElement::setElt | ( | const int | unit,
|  | const SbUniqueId | nodeid,
|  | const SbVec3s & | size,
|  | const int | numComponents,
|  | const unsigned char * | bytes,
|  | const Wrap | wrapS,
|  | const Wrap | wrapT,
|  | const Wrap | wrapR,
|  | const Model | model,
|  | const SbColor & | blendColor )
| virtual

FIXME: write doc.

## ◆ hasTransparency()

SbBool SoMultiTextureImageElement::hasTransparency | ( | const int | unit = 0 | ) | const
| virtual

Called by containsTransparency(). Returns TRUE if image data has transparency. Default method does a very poor job of detecting this, since it returns TRUE when the number of components are 2 or

1. Override whenever it is important to know this (SoGLTextureImageElement overrides it to avoid transparency handling where possible).

Reimplemented in SoGLMultiTextureImageElement.

## ◆ getNumUnits()

int SoMultiTextureImageElement::getNumUnits | ( |  | ) | const
| protected

Get the number of units with image data set.

The documentation for this class was generated from the following files:

- SoMultiTextureImageElement.h
- SoMultiTextureImageElement.cpp